#
# Conditional build:
%bcond_with	tests		# build without tests

Summary:	fpm - package building and mangling
Name:		fpm
Version:	1.5.0
Release:	3
License:	MIT-like
Group:		Development/Languages
Source0:	https://github.com/jordansissel/fpm/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	8451e8bc931e5316222f62f6858d80cc
Source1:	filesystem_list
Patch0:		templates.patch
Patch1:		tmppath.patch
Patch2:		config-attrs.patch
Patch3:		pld-init.d-dir.patch
Patch4:		optional-packages.patch
URL:		https://github.com/jordansissel/fpm
BuildRequires:	rpm-rubyprov
BuildRequires:	rpmbuild(macros) >= 1.665
BuildRequires:	sed >= 4.0
%if %{with tests}
BuildRequires:	ruby-insist >= 0.0.6
BuildRequires:	ruby-pry
BuildRequires:	ruby-rspec < 3.1
BuildRequires:	ruby-rspec >= 3.0.0
BuildRequires:	ruby-stud
%endif
Suggests:	rpm-build
Obsoletes:	ruby-fpm <= 1.4.0-2
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# skip python dependency generator
%define		_noautoreqfiles %{ruby_vendorlibdir}/%{name}/package/pyfpm/get_metadata.py

%description
Convert directories, rpms, python eggs, rubygems, and more to rpms,
debs, solaris packages and more. Win at package management without
wasting pointless hours debugging bad rpm specs!

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%{__sed} -i -e '1 s,#!.*ruby,#!%{__ruby},' bin/*

# replace filesystem_list with pld version
cp -p %{SOURCE1} templates/rpm/filesystem_list

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
# make gemspec self-contained
ruby -r rubygems -e 'spec = eval(File.read("%{name}.gemspec"))
	File.open("%{name}-%{version}.gemspec", "w") do |file|
	file.puts spec.to_ruby_for_cache
end'

%if %{with tests}
rspec
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{ruby_vendorlibdir},%{ruby_specdir},%{_bindir}}
cp -a lib/* $RPM_BUILD_ROOT%{ruby_vendorlibdir}
cp -a bin/* $RPM_BUILD_ROOT%{_bindir}
cp -a templates $RPM_BUILD_ROOT%{ruby_vendorlibdir}/%{name}
cp -p %{name}-%{version}.gemspec $RPM_BUILD_ROOT%{ruby_specdir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/fpm
%{ruby_vendorlibdir}/%{name}.rb
%{ruby_vendorlibdir}/%{name}
%{ruby_specdir}/%{name}-%{version}.gemspec
%changelog
* Thu Jun 02 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/fpm.git;a=log;h=master

* Thu Jun 02 2016 Elan Ruusamäe <glen@delfi.ee> 58e94a4
- xz also optional

* Thu Jun 02 2016 Elan Ruusamäe <glen@delfi.ee> b042f6a
- do not load corefines

* Mon May 09 2016 Elan Ruusamäe <glen@delfi.ee> 5d12b48
- skip optional dependencies

* Mon May 09 2016 Elan Ruusamäe <glen@delfi.ee> ea749cb
- drop autogenerated deps

* Mon May 09 2016 Elan Ruusamäe <glen@delfi.ee> 4ad3b96
- up to 1.5.0

* Tue Sep 01 2015 Elan Ruusamäe <glen@delfi.ee> 2a24ca3
- disable python dependency generator

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> 02e4017
- add tmppath.patch

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> ded550f
- use static filesystem_list, to keep package still noarch

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> dffea34
- replace with x86_64, it contains more paths

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> a3dd7c1
- replace filesystem list with pld one

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> 373554a
- add filesystem list from fpm-1.4.0

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> ff173b4
- replace filesystem_list with pld version

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> 72329b5
- insist 0.0.6 required for tests

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> cb102dd
- run rspec when tests enabled

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> beabb47
- use github tarball which would include rspec tests

* Tue Aug 25 2015 Elan Ruusamäe <glen@delfi.ee> 94ae815
- fix path to pld init.d dir

* Mon Aug 24 2015 Elan Ruusamäe <glen@delfi.ee> c978479
- use pld style config noreplace attributes

* Fri Aug 21 2015 Elan Ruusamäe <glen@delfi.ee> 18532f9
- hack tmppath macro

* Mon Aug 10 2015 Elan Ruusamäe <glen@delfi.ee> 73f3539
- rename package to "fpm"

* Mon Aug 10 2015 Elan Ruusamäe <glen@delfi.ee> 44e2d7b
- cleanup backups after patching

